using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;


namespace DrawingApp
{
    public partial class Form1 : Form
    {
        List<IDrawingObject> DrawingObjects = new List<IDrawingObject>();

        private bool isMousePressed = false;
        private Point P1;
        private Point P2;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_MouseDown(object sender, MouseEventArgs e)
        {
            P1 = e.Location;
            isMousePressed = true;

        }

        private void Form1_MouseUp(object sender, MouseEventArgs e)
        {
            P2 = e.Location;
            Graphics g = CreateGraphics();
            IDrawingObject b = CreateGraphicObject();
            if (b != null)
            {
                b.Draw(g);

                DrawingObjects.Add(b);
            }
            isMousePressed = false;
        }

        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            if (isMousePressed)
            {
                P2 = e.Location;
                Graphics g = CreateGraphics();
                g.Clear(this.BackColor);

                IDrawingObject b = CreateGraphicObject();
                if (b != null)
                {
                    b.Draw(g);
                }
                DrawCollection(g);
            }
        }

        private IDrawingObject CreateGraphicObject()
        {
            int x, y, w, h;
            x = Math.Min(P1.X, P2.X);
            w = Math.Abs(P1.X - P2.X);
            y = Math.Min(P1.Y, P2.Y);
            h = Math.Abs(P1.Y - P2.Y);

            IDrawingObject b = null;
            if (rbSquare.Checked)
            {
                b = new MyRectangle(x, y, w, h);
            }
            else if (rbCircle.Checked)
            {
                b = new MyCircle(x, y, w, h);
            }
            else if (rbLine.Checked)
            {
                b = new MyLine(P1, P2);
            }

            return b;
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            DrawCollection(e.Graphics);
        }
        private void DrawCollection(Graphics g, bool clear = false)
        {
            if (clear)
            {
                g.Clear(this.BackColor);
            }
            foreach (var drawingObject in DrawingObjects)
            {
                //if (drawingObject != null)
                //{
                drawingObject.Draw(g);
                //}
            }


        }



        #region Move Objects

        private void btnNorth_Click(object sender, EventArgs e)
        {
            MoveObjects(0.0, (int)(numericUpDown1.Value));
        }

        private void btnNorthEast_Click(object sender, EventArgs e)
        {
            MoveObjects(45.0, (int)(numericUpDown1.Value));
        }

        private void btnEast_Click(object sender, EventArgs e)
        {
            MoveObjects(90.0, (int)(numericUpDown1.Value));
        }

        private void btnSouthEast_Click(object sender, EventArgs e)
        {
            MoveObjects(135.0, (int)(numericUpDown1.Value));
        }

        private void btnSouth_Click(object sender, EventArgs e)
        {
            MoveObjects(180.0, (int)(numericUpDown1.Value));
        }

        private void btnSouthWest_Click(object sender, EventArgs e)
        {
            MoveObjects(225.0, (int)(numericUpDown1.Value));
        }

        private void btnWest_Click(object sender, EventArgs e)
        {
            MoveObjects(270.0, (int)(numericUpDown1.Value));
        }

        private void btnNorthWest_Click(object sender, EventArgs e)
        {
            MoveObjects(315.0, (int)(numericUpDown1.Value));
        }

        private void MoveObjects(double angle, int distance)
        {
            foreach (var drawingObject in DrawingObjects)
            {
                IMovable b = drawingObject as IMovable;
                if (b != null)
                {
                    b.Move(angle, distance);
                }
            }

            Graphics g = CreateGraphics();
            DrawCollection(g, true);
        }

        #endregion
    }


}