using System;
using System.Drawing;
using System.Runtime.Remoting.Metadata.W3cXsd2001;

namespace DrawingApp
{
    abstract class MyBase : IDrawingObject, IMovable
    {
        static public int newIndex = 0;

        public int index;

        protected int X;
        public int Y;

        public MyBase(int x, int y)
        {
            X = x;
            Y = y;
            newIndex++;
            index = newIndex;
        }

        public abstract void Draw(Graphics canvas);

        public virtual void Move(int dX, int dY)
        {
            X += dX;
            Y -= dY;
        }

        public void Move(double degrees, int len)
        {
            double angle = (Math.PI / 180) * degrees;
            double sinAngle = Math.Sin(angle);
            double cosAngle = Math.Cos(angle);

            int dx = (int)(sinAngle * len);
            int dy = (int)(cosAngle * len);

            Move(dx, dy);
        }
    }
}