using System;
using System.Drawing;

namespace DrawingApp
{
    public class MyLine : IDrawingObject, IMovable
    {
        public Point p1, p2;
        private Pen pen;

        public MyLine(Point p1, Point p2)
        {
            this.p1 = p1;
            this.p2 = p2;
            pen = Pens.Red;

        }

        public void Draw(Graphics canvas)
        {
            canvas.DrawLine(pen, p1, p2);
        }

        public virtual void Move(int dX, int dY)
        {
            p1.X += dX;
            p1.Y -= dY;
            p2.X += dX;
            p2.Y -= dY;
        }

        public void Move(double degrees, int len)
        {
            double angle = (Math.PI / 180) * degrees;
            double sinAngle = Math.Sin(angle);
            double cosAngle = Math.Cos(angle);

            int dx = (int)(sinAngle * len);
            int dy = (int)(cosAngle * len);

            Move(dx, dy);
        }
    }
}